;------------------------------------------------------------------------------------------------------------
;  AuBeurre v.1.0     -     Unpacker for Escargot
;     By elooo        -     http://elooo.c.la
;------------------------------------------------------------------------------------------------------------
;  An other unpacker for the Meat's PE Protector named Escargot.
;  This one works as a debugger because IT IS a basic debugger ;). 
;  The loops used to get the important addresses are delibarate, in order no to use the fixed offsets.
;  Moreover, I tried to use a lot of different ways to stop at a defined address or to bypass the jumps.
;  I hope it will be appreciated :)
;------------------------------------------------------------------------------------------------------------

;------------------------------------------------------------------------------------------------------------
.486p
.model flat, stdcall
option casemap :none

;--------------------------------------------------------------------------------
;  Includes
;--------------------------------------------------------------------------------
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\kernel32.lib

;--------------------------------------------------------------------------------
;  Macros
;--------------------------------------------------------------------------------
	CreateData MACRO quoted_text:VARARG
	LOCAL Local_Etiquette
	.data
	Local_Etiquette db quoted_text,0
	.code
	EXITM <Local_Etiquette>
	ENDM
	
	SADD MACRO quoted_text:VARARG
	EXITM <ADDR CreateData(quoted_text)>
	ENDM
	
;--------------------------------------------------------------------------------
;  Defined data
;--------------------------------------------------------------------------------	
.data
ofn		   				OPENFILENAME <>
startinfo				STARTUPINFO <>
pi 						PROCESS_INFORMATION <>
DBEvent 				DEBUG_EVENT <> 
align dword
context					CONTEXT	<>

AppNameOpen				db "AuBeurre : Elooo's Unpacker for Escargot - Open a file",0
AppNameSave				db "AuBeurre : Elooo's Unpacker for Escargot - Save the file",0
Filter 					db "Encrypted files",0,0,0
Filter2 				db "Decrypted Files",0,0,0

opcode					db 0C6h	
int3					db 0CCh
;--------------------------------------------------------------------------------
;  Undefined data
;--------------------------------------------------------------------------------	
.data?
bufferName 				db 512 dup(?)			; name of the file
hFile					dd ?					; file handle
ptrMap					dd ?					; pointer to the mapped file
NbSections				dd ?					; number of sections
OEP						dd ?					; VA of the OEP
addrIT					dd ?					; VA of the Import Table
Bytes					dd ?					; number of read/written bytes
ImageBase				dd ?					; imagebase of the encrypted file
DBThread				dd ?					; handle of the debugged thread
EP						dd ?					; EntryPoint of the encrypted file
SizeOfImage				dd ?					; SizeOfImage of the encrypted file
ExitCode				dd ?					; ExitCode
addrIsDebugger			dd ?					; VA of the instruction after IsDebuggerPresent()
addrDestroyedPE			dd ?					; VA of the jnz related to the destruction of the PE Header
addrRetOEP				dd ?					; VA of the "ret OEP"
savedByte				dd ?					; byte stored before the overwriting with a 0xCC
;--------------------------------------------------------------------------------
;  Code
;--------------------------------------------------------------------------------	
.code
start:
;--------------------------------------------------
;   Open file dialog
;--------------------------------------------------
	mov ofn.lStructSize,SIZEOF ofn
	mov  ofn.lpstrFilter, OFFSET Filter
	mov  ofn.lpstrFile, OFFSET bufferName
	mov ofn.lpstrTitle,offset AppNameOpen
	mov  ofn.nMaxFile,512
	mov  ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
	invoke GetOpenFileName, ADDR ofn
	
	.if eax!=NULL
		;--------------------------------------------------
		;   Create the process
		;--------------------------------------------------					
		invoke GetStartupInfo,addr startinfo 
		invoke CreateProcess, addr bufferName, NULL, NULL, NULL, FALSE, DEBUG_PROCESS or DEBUG_ONLY_THIS_PROCESS,NULL, NULL, offset startinfo, offset pi 

				.while TRUE
					;--------------------------------------------------
					;   Wait for a debug event
					;--------------------------------------------------
					invoke WaitForDebugEvent, addr DBEvent, INFINITE
					mov eax, DBEvent.dwDebugEventCode
					test eax, eax
					jz ExitDebug
						;--------------------------------------------------
						;   Exit_Process_Debug_Event
						;--------------------------------------------------		
						.if eax == EXIT_PROCESS_DEBUG_EVENT
							jmp ExitDebug
						;--------------------------------------------------
						;   Create_Process_Debug_Event
						;--------------------------------------------------									
						.elseif eax == CREATE_PROCESS_DEBUG_EVENT
							;--------------------------------------------------
							;   Store the ImageBase
							;--------------------------------------------------	
							push DBEvent.u.CreateProcessInfo.lpBaseOfImage
							pop ImageBase	
							;--------------------------------------------------
							;   Store the handle of the debuggee
							;--------------------------------------------------								 
							push DBEvent.u.CreateProcessInfo.hThread
							pop DBThread 
							;--------------------------------------------------
							;   Check if it is a "Win/Dos" executable file
							; 	(not really needed because if it is not the case,
							;   the creation of the process will fail...) 
							;--------------------------------------------------								
						    invoke ReadProcessMemory, pi.hProcess, ImageBase, addr Bytes, 2, NULL
							cmp word ptr [Bytes], "ZM"
							jz OK_MZ
							invoke MessageBox,NULL, SADD("It is not a valid Windows/Dos executable file"),SADD("Error"), MB_OK+MB_ICONERROR
							jmp ExitDebug
OK_MZ:
							;--------------------------------------------------
							;   Check if it is a PE file
							;--------------------------------------------------	
							mov eax, ImageBase
							push eax
							add eax, 3Ch
							invoke ReadProcessMemory, pi.hProcess, eax,addr Bytes, 4, NULL
							pop eax
							add eax, dword ptr Bytes
							push Bytes
							invoke ReadProcessMemory, pi.hProcess, eax,addr Bytes, 2, NULL
							cmp word ptr Bytes, "EP"
							jz PE_OK
							invoke MessageBox,NULL, SADD("It is not a valid PE file"),SADD("Error"), MB_OK+MB_ICONERROR
							jmp ExitDebug
PE_OK:						
							;--------------------------------------------------
							;   get the entrypoint of the encrypted file
							;--------------------------------------------------	
							pop Bytes
							mov eax, Bytes
							add eax, 28h
							add eax, ImageBase
							push eax
							invoke ReadProcessMemory, pi.hProcess, eax,addr Bytes, 4, NULL	
							mov eax, Bytes
							mov eax, eax
							add eax, ImageBase
							mov EP, eax
							;--------------------------------------------------
							;   get the SizeOfImage
							;--------------------------------------------------								
							pop eax
							add eax, 28h
							invoke ReadProcessMemory, pi.hProcess, eax,addr SizeOfImage, 4, NULL	
							;--------------------------------------------------
							;  Check if the file is encrypted with Escargot
							;--------------------------------------------------							
							mov eax, EP
							add eax, 2
							invoke ReadProcessMemory, pi.hProcess, eax,addr Bytes, 4, NULL
							cmp dword ptr [Bytes], 312E3040h
   							jz OK_Signature
							invoke MessageBox,NULL, SADD("This file is not encrypted with Escargot"),SADD("Error"), MB_OK+MB_ICONERROR
							jmp ExitDebug						
OK_Signature:  
							;--------------------------------------------------
							;  Look for the VA of the call to IsDebuggerPresent
							;--------------------------------------------------     								
							mov edx, EP
							mov ecx, EP
							add edx, 30h
							.while (ecx < edx)
								push ecx
								push edx
								invoke ReadProcessMemory, pi.hProcess, ecx,addr Bytes, 4, NULL
								pop edx
								pop ecx
								cmp dword ptr Bytes, 0B850D0FFh
								jz IsDebuggerFound
								inc ecx
							.endw							
IsDebuggerFound:	
							;--------------------------------------------------
							;  Hardware Breakpoint on the next instruction
							;  (in order to modify the return value)
							;-------------------------------------------------- 		
							add ecx, 2
							mov addrIsDebugger, ecx
							push ecx
					       	mov context.ContextFlags,  CONTEXT_DEBUG_REGISTERS
							invoke GetThreadContext, DBThread, addr context
							pop ecx
							mov context.iDr7, 401h
							mov context.iDr0, ecx
							invoke SetThreadContext, DBThread, addr context 							
							 								
						;--------------------------------------------------
						;   Exception_Debug_Event
						;--------------------------------------------------	
						.elseif eax == EXCEPTION_DEBUG_EVENT
							mov eax, DBEvent.u.Exception.pExceptionRecord.ExceptionCode
							;--------------------------------------------------
							;   Int3h Breakpoint
							;--------------------------------------------------								
							.if eax == EXCEPTION_BREAKPOINT		
								;--------------------------------------------------
								;  Each time a int3h breakpoint is detected, we
								;  check the value of eip in order to run the
								;  correct part of code.
								;  Windows sends a signal (an int3h breakpoint)
								;  before the entrypoint of a file is reached, that's
								;  why this check is useful here too 
								;-------------------------------------------------- 														
								mov context.ContextFlags, CONTEXT_CONTROL
								invoke GetThreadContext, DBThread, addr context	
								mov eax, context.regEip
								;--------------------------------------------------
								;  Activate the Trap Flag (to execute only one
								;  instruction : similar to "sti" in Ollydbg) if we
								;  are at the VA of the RET
								;  We overwrite the 0xCC that we put before by the 
								;  correct opcode saved in "savedByte" (= 0xC3 here)
								;-------------------------------------------------- 								
								.if (eax == addrRetOEP)
									dec eax
									invoke WriteProcessMemory, pi.hProcess, eax,addr savedByte, 1, NULL
									mov context.ContextFlags, CONTEXT_CONTROL 
									invoke GetThreadContext, DBThread, addr context
									or context.regFlag,100h
									dec context.regEip
									invoke SetThreadContext, DBThread, addr context																		
								.endif
								invoke ContinueDebugEvent, DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_CONTINUE
								.continue																
							;--------------------------------------------------
							;   Int1h Breakpoint
							;--------------------------------------------------									
							.elseif eax == EXCEPTION_SINGLE_STEP
								;--------------------------------------------------
								;  This check of reg.Eip has already been explained
								;  above ;)
								;-------------------------------------------------- 							
								mov context.ContextFlags, CONTEXT_CONTROL
								invoke GetThreadContext, DBThread, addr context	
								mov eax, context.regEip

								;--------------------------------------------------
								;  If we are at the VA of the instruction following
								;  the IsDebuggerPresent call function, we remove 
								;  the hardware breakpoint, and we set eax to 0
								;--------------------------------------------------								
								cmp eax, addrIsDebugger
								jnz DestroyedPE								
								mov context.ContextFlags, CONTEXT_DEBUG_REGISTERS
								invoke GetThreadContext, DBThread, addr context									
								 mov context.iDr0, 0		 											
								invoke SetThreadContext, DBThread, addr context 
								mov context.ContextFlags, CONTEXT_INTEGER
								mov context.regEax, 0 
								invoke SetThreadContext, DBThread, addr context 
								;--------------------------------------------------
								;  We look for the jnz related to the destruction
								;  of the PE Header
								;--------------------------------------------------																	
								mov edx, addrIsDebugger
								mov ecx, addrIsDebugger
								add edx, 10h
								.while (ecx < edx)
									push ecx
									push edx
									invoke ReadProcessMemory, pi.hProcess, ecx,addr Bytes, 4, NULL
									pop edx
									pop ecx
									cmp dword ptr Bytes, 2D751337h
									jz DestroyedPEfound
									inc ecx
								.endw	
DestroyedPEfound:				;--------------------------------------------------
								;  When found, set an hardware breakpoint on it
								;--------------------------------------------------	
								add ecx, 2
								mov addrDestroyedPE, ecx
								push ecx
						       	mov context.ContextFlags,  CONTEXT_DEBUG_REGISTERS
								invoke GetThreadContext, DBThread, addr context
								pop ecx
								mov context.iDr7, 401h
								mov context.iDr0, ecx
								invoke SetThreadContext, DBThread, addr context 
								invoke ContinueDebugEvent, DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_CONTINUE
								.continue
																								
DestroyedPE:					;--------------------------------------------------
								;  If we are at the VA of jnz related to the
								;  destruction of the PE Header, we remove the hardware
								;  breakpoint, and we set the Zero Flag to 0 (in
								;  order to force the jnz :) )
								;--------------------------------------------------									
								cmp eax, addrDestroyedPE	
								jnz addrOEP	
								mov context.ContextFlags, CONTEXT_DEBUG_REGISTERS
								invoke GetThreadContext, DBThread, addr context									
								 mov context.iDr0, 0		 											
								invoke SetThreadContext, DBThread, addr context
								mov context.ContextFlags, CONTEXT_CONTROL
								invoke GetThreadContext, DBThread, addr context	
								and context.regFlag,0FFFFFFBFh		
								invoke SetThreadContext, DBThread, addr context
								;--------------------------------------------------									
								;  Then, we look for the VA of the push "addr IAT"
								;--------------------------------------------------									
								mov edx, addrDestroyedPE
								mov ecx, addrDestroyedPE
								add edx, 70h
								.while (ecx < edx)
									push ecx
									push edx
									invoke ReadProcessMemory, pi.hProcess, ecx,addr Bytes, 4, NULL
									pop edx
									pop ecx
									cmp dword ptr Bytes, 0BE0BADC0h
									jz GetaddrIAT
									inc ecx
								.endw
GetaddrIAT:						;--------------------------------------------------									
								;  When found, we store it in "addrIT" and we look
								;  for the jump to the beginning of the code that will
								;  resolve the IAT
								;--------------------------------------------------
								add ecx, 4
								push ecx
								invoke ReadProcessMemory, pi.hProcess, ecx,addr addrIT, 4, NULL
								pop ecx
								mov edx, ecx
								add edx, 10h
								.while (ecx < edx)
									push ecx
									push edx
									invoke ReadProcessMemory, pi.hProcess, ecx,addr Bytes, 4, NULL
									pop edx
									pop ecx
									cmp dword ptr Bytes, 0ACE9h
									jz JmpResolveITFound
									inc ecx
								.endw
JmpResolveITFound:				;--------------------------------------------------
								;  We overwrite the destination of this jump to
								;  bypass the routine of the imports resolving
								;--------------------------------------------------
								push ecx
								inc ecx
								invoke WriteProcessMemory, pi.hProcess, ecx,addr opcode, 1, NULL
								;--------------------------------------------------
								;  And we look for the VA of the RET instruction
								;--------------------------------------------------								
								pop ecx		
								mov edx, ecx
								add edx, 100h
								.while (ecx < edx)
									push ecx
									push edx
									invoke ReadProcessMemory, pi.hProcess, ecx,addr Bytes, 4, NULL
									pop edx
									pop ecx
									cmp dword ptr Bytes, 686104C4h
									jz GetRetOEP
									inc ecx
								.endw															
GetRetOEP:						;--------------------------------------------------
								;  When the VA of the RET instruction is found, we 
								;  store the current opcode (0xC3) in "savedByte", we
								;  store the value of the Original EntryPoint in
								;  "OEP", and we overwrite the RET opcode by 0xCC
								;  (to put an hardware breakpoint)
								;--------------------------------------------------	
								add ecx, 4
								push ecx
								invoke ReadProcessMemory, pi.hProcess, ecx, addr OEP, 4, NULL
								pop ecx
								add ecx, 4
								push ecx
								invoke ReadProcessMemory, pi.hProcess, ecx,addr savedByte, 1, NULL
								pop ecx
								mov addrRetOEP, ecx
								inc addrRetOEP
								invoke WriteProcessMemory, pi.hProcess, ecx,addr int3, 1, NULL
								invoke ContinueDebugEvent, DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_CONTINUE
								.continue	
								
addrOEP:						;--------------------------------------------------
								;  When we are at the OEP, the process is decrypted
								;  and we dump the process in allocated memory
								;  (in order to get a copy of the debuggee)
								;--------------------------------------------------
								cmp eax, OEP	
								jnz Error
								mov context.ContextFlags, CONTEXT_CONTROL 
								invoke GetThreadContext, DBThread, addr context
								or context.regFlag,100h
								invoke SetThreadContext, DBThread, addr context								

								invoke VirtualAlloc, 0, SizeOfImage, MEM_COMMIT, PAGE_READWRITE
								mov ptrMap, eax
								invoke ReadProcessMemory, pi.hProcess, ImageBase, eax, SizeOfImage, NULL
								;--------------------------------------------------
								;  When rebuild the file, fixing the correct values
								;  in the PE header
								;--------------------------------------------------
								call Rebuild
								;--------------------------------------------------
								;  When save our memory dumped process in a file
								;--------------------------------------------------								
								call SaveFile
								invoke	VirtualFree, ptrMap, SizeOfImage, MEM_DECOMMIT
								invoke	CloseHandle, hFile
								invoke MessageBox,NULL, SADD("File decrypted"),SADD("Finish !"), MB_OK+MB_ICONINFORMATION								
								jmp ExitDebug
								
Error:							invoke MessageBox,NULL, SADD("Error during the unpacking process..."),SADD("Doh !"), MB_OK+MB_ICONERROR	
								jmp ExitDebug																								
							.endif
						.endif	
					;--------------------------------------------------
					;   No event-> Loop
					;--------------------------------------------------						
					invoke ContinueDebugEvent, DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED						
				.endw	

ExitDebug:	
		mov ExitCode, 0		
		invoke	GetExitCodeThread, pi.hThread, offset ExitCode
		invoke	TerminateThread, pi.hThread, eax		
		invoke	CloseHandle, pi.hProcess
		invoke	CloseHandle, pi.hThread
		jmp finish



	;--------------------------------------------------
	;   Error GetOpenFileName
	;--------------------------------------------------	
	.else
		invoke MessageBox,NULL, SADD("GetOpenFileName"),SADD("Error"), MB_OK+MB_ICONERROR				
	.endif	

;--------------------------------------------------
;   Aborted / Finished  
;--------------------------------------------------
finish:	
	invoke ExitProcess, 0	

	

Rebuild proc
;--------------------------------------------------------------------------------
;  - Remove the last section
;  - Store the RVA of the OEP in the PE header
;  - Fix the address of the Import Table
;  - Fix the SizeOfImage
;  - Get the size of the new file
;--------------------------------------------------------------------------------	

	mov edi, ptrMap
	assume edi:ptr IMAGE_DOS_HEADER  
	add edi, [edi].e_lfanew						
	assume edi:ptr IMAGE_NT_HEADERS
	;--------------------------------------------------
	;   Remove the last section
	;--------------------------------------------------	
	mov ax, [edi].FileHeader.NumberOfSections
	dec ax
	mov [edi].FileHeader.NumberOfSections, ax
	mov word ptr NbSections, ax
	;--------------------------------------------------
	;   Store the RVA of the OEP in the PE header
	;--------------------------------------------------
	mov esi, edi
	assume esi:ptr IMAGE_NT_HEADERS
	mov eax, [esi].OptionalHeader.ImageBase
	sub OEP, eax
	push OEP
	pop [esi].OptionalHeader.AddressOfEntryPoint
	;--------------------------------------------------
	;   Fix the address of the Import Table
	;--------------------------------------------------
	mov eax, [esi].OptionalHeader.ImageBase
	sub addrIT, eax
	push addrIT
	pop [esi].OptionalHeader.DataDirectory[8].VirtualAddress		;IMAGE_DIRECTORY_ENTRY_IMPORT.VirtualAddress
	mov [esi].OptionalHeader.DataDirectory[96].VirtualAddress, 0 	;IMAGE_DIRECTORY_ENTRY_IAT.VirtualAddress
	mov [esi].OptionalHeader.DataDirectory[100].VirtualAddress, 0 	;IMAGE_DIRECTORY_ENTRY_IAT.Size
	;--------------------------------------------------
	;   Fix the BaseOfCode
	;--------------------------------------------------	
	add edi, sizeof IMAGE_NT_HEADERS
	assume edi:ptr IMAGE_SECTION_HEADER
	push [edi].VirtualAddress										
	pop [esi].OptionalHeader.BaseOfCode		
	;--------------------------------------------------
	;   Fix the SizeOfImage
	;--------------------------------------------------	
	push edi
	mov eax, NbSections
	dec eax
	mov ecx, sizeof IMAGE_SECTION_HEADER
	mul ecx
	add edi, eax
	mov eax, [edi].VirtualAddress	
	add eax, [edi].Misc.VirtualSize 
	push eax
	pop [esi].OptionalHeader.SizeOfImage
	;--------------------------------------------------
	;   Fix the Raw offsets and the Raw sizes
	;--------------------------------------------------	
	pop edi
	xor ecx, ecx
	.while (ecx < NbSections)
		push [edi].VirtualAddress
		pop [edi].PointerToRawData
		push [edi].Misc.VirtualSize
		pop [edi].SizeOfRawData
		add edi, 28h
		inc ecx
	.endw		
	RET
Rebuild EndP

SaveFile proc
;--------------------------------------------------
;   Save file dialog
;--------------------------------------------------
	mov ofn.lStructSize,SIZEOF ofn
	mov  ofn.lpstrFilter, OFFSET Filter2
	mov  ofn.lpstrFile, OFFSET bufferName
	mov dword ptr ds:bufferName,0
	mov ofn.lpstrTitle,offset AppNameSave
	mov  ofn.nMaxFile,512
	mov  ofn.Flags, OFN_PATHMUSTEXIST or OFN_LONGNAMES or  OFN_EXPLORER
	invoke GetSaveFileName, ADDR ofn
	
	.if eax!=NULL	
		;--------------------------------------------------		
		; Create the decrypted file
		;--------------------------------------------------		
		invoke CreateFile, addr bufferName, GENERIC_READ+GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
		.if eax!=INVALID_HANDLE_VALUE
			mov hFile, eax
			invoke WriteFile, hFile, ptrMap, SizeOfImage, offset Bytes, NULL
			test eax, eax
			jz BadWrite
			ret
BadWrite:
			;--------------------------------------------------	
			; Error WriteFile
			;--------------------------------------------------						
			invoke MessageBox,NULL, SADD("WriteFile"),SADD("Error"), MB_OK+MB_ICONERROR	
			xor eax, eax
			ret				
		;--------------------------------------------------	
		; Error CreateFile
		;--------------------------------------------------				
		.else
			invoke MessageBox,NULL, SADD("CreateFile"),SADD("Error"), MB_OK+MB_ICONERROR	
			xor eax, eax
			ret
		.endif			
	;--------------------------------------------------
	; Error GetSaveFileName
	;--------------------------------------------------			
	.else
		invoke MessageBox,NULL, SADD("GetSaveFileName"),SADD("Error"), MB_OK+MB_ICONERROR
		xor eax, eax			
	.endif
	
	Ret
SaveFile EndP

END start	